//+------------------------------------------------------------------+
//|                                                         Test.mq5 |
//|                                                      Zloy Koldun |
//+------------------------------------------------------------------+
#property copyright "Zloy Koldun"
#property version   "1.00"

#include <QuickSort.mqh>

struct MyStruct
{
   double A;
   double B;
   double C;
};

typedef bool (*FuncLess)( const MyStruct&, const MyStruct& );

bool Less( const MyStruct& struct1, const MyStruct& struct2 )
{
   if( struct1.A != struct2.A ){
      return struct1.A < struct2.A;
   }
   if( struct1.B != struct2.B ){
      return struct1.B < struct2.B;
   }
   return struct1.C < struct2.C;
}

void OnStart()
{
   MyStruct structArray[];
   ArrayResize( structArray, 25 );

   for( int i = 0; i < 25; i++ ){
      structArray[i].A = rand();
      structArray[i].B = rand();
      structArray[i].C = rand();
   }

   QuickSort< MyStruct, FuncLess >( structArray, Less );

   for( int i = 0; i < 25; i++ )
   {
      PrintFormat( "structArray[%i] = %f %f %f", i, structArray[i].A, structArray[i].B, structArray[i].C );
   }
}
